JUCE: MidiInput Class Reference

JUCE

Public Member Functions | Static Public Member Functions | List of all members
MidiInput Class Referencefinal

Represents a midi input device. More...

## Public Member Functions
| ~MidiInput ()
| Destructor. More...
void | start ()
| Starts the device running. More...
void | stop ()
| Stops the device running. More...
MidiDeviceInfo | getDeviceInfo () const noexcept
| Returns the MidiDeviceInfo struct containing some information about this device. More...
String | getIdentifier () const noexcept
| Returns the identifier of this device. More...
String | getName () const noexcept
| Returns the name of this device. More...
void | setName (const String &newName) noexcept
| Sets a custom name for the device. More...

## Static Public Member Functions
static Array< MidiDeviceInfo > | getAvailableDevices ()
| Returns a list of the available midi input devices. More...
static MidiDeviceInfo | getDefaultDevice ()
| Returns the MidiDeviceInfo of the default midi input device to use. More...
static std::unique_ptr< MidiInput > | openDevice (const String &deviceIdentifier, MidiInputCallback *callback)
| Tries to open one of the midi input devices. More...
static std::unique_ptr< MidiInput > | createNewDevice (const String &deviceName, MidiInputCallback *callback)
| This will try to create a new midi input device (only available on Linux, macOS and iOS). More...
static StringArray | getDevices ()
| Deprecated. More...
static int | getDefaultDeviceIndex ()
| Deprecated. More...
static std::unique_ptr< MidiInput > | openDevice (int, MidiInputCallback *)
| Deprecated. More...

## Detailed Description

Represents a midi input device.

To create one of these, use the static getAvailableDevices() method to find out what inputs are available, and then use the openDevice() method to try to open one.

See also
  MidiOutput

## Constructor & Destructor Documentation

## ◆ ~MidiInput()

MidiInput::~MidiInput | ( |  | ) |

Destructor.

## Member Function Documentation

## ◆ getAvailableDevices()

static Array<MidiDeviceInfo> MidiInput::getAvailableDevices | ( |  | ) |
| static

Returns a list of the available midi input devices.

You can open one of the devices by passing its identifier into the openDevice() method.

See also
  MidiDeviceInfo, getDevices, getDefaultDeviceIndex, openDevice

## ◆ getDefaultDevice()

static MidiDeviceInfo MidiInput::getDefaultDevice | ( |  | ) |
| static

Returns the MidiDeviceInfo of the default midi input device to use.

## ◆ openDevice() [1/2]

static std::unique_ptr<MidiInput> MidiInput::openDevice | ( | const String & | deviceIdentifier,
|  | MidiInputCallback * | callback
| ) |  |
| static

Tries to open one of the midi input devices.

This will return a MidiInput object if it manages to open it, you can then call start() and stop() on this device.

If the device can't be opened, this will return an empty object.

Parameters

  deviceIdentifier | the ID of the device to open - use the getAvailableDevices() method to find the available devices that can be opened
  callback | the object that will receive the midi messages from this device

See also
  MidiInputCallback, getDevices

## ◆ createNewDevice()

static std::unique_ptr<MidiInput> MidiInput::createNewDevice | ( | const String & | deviceName,
|  | MidiInputCallback * | callback
| ) |  |
| static

This will try to create a new midi input device (only available on Linux, macOS and iOS).

This will attempt to create a new midi input device with the specified name for other apps to connect to.

NB - if you are calling this method on iOS you must have enabled the "Audio Background Capability" setting in the iOS exporter otherwise this method will fail.

Returns an empty object if a device can't be created.

Parameters

  deviceName | the name of the device to create
  callback | the object that will receive the midi messages from this device

## ◆ start()

void MidiInput::start | ( |  | ) |

Starts the device running.

After calling this, the device will start sending midi messages to the MidiInputCallback object that was specified when the openDevice() method was called.

See also
  stop

## ◆ stop()

void MidiInput::stop | ( |  | ) |

Stops the device running.

See also
  start

## ◆ getDeviceInfo()

MidiDeviceInfo MidiInput::getDeviceInfo | ( |  | ) | const
| noexcept

Returns the MidiDeviceInfo struct containing some information about this device.

## ◆ getIdentifier()

String MidiInput::getIdentifier | ( |  | ) | const
| noexcept

Returns the identifier of this device.

## ◆ getName()

String MidiInput::getName | ( |  | ) | const
| noexcept

Returns the name of this device.

## ◆ setName()

void MidiInput::setName | ( | const String & | newName | ) |
| noexcept

Sets a custom name for the device.

## ◆ getDevices()

static StringArray MidiInput::getDevices | ( |  | ) |
| static

Deprecated.

## ◆ getDefaultDeviceIndex()

static int MidiInput::getDefaultDeviceIndex | ( |  | ) |
| static

Deprecated.

## ◆ openDevice() [2/2]

static std::unique_ptr<MidiInput> MidiInput::openDevice | ( | int | ,
|  | MidiInputCallback * |
| ) |  |
| static

Deprecated.

The documentation for this class was generated from the following file:

- juce_MidiDevices.h